Index: reactos/apps/tests/isotest/isotest.c
===================================================================
RCS file: /CVS/ReactOS/reactos/apps/tests/isotest/isotest.c,v
retrieving revision 1.5
diff -u -r1.5 isotest.c
--- reactos/apps/tests/isotest/isotest.c	14 Nov 2003 17:13:17 -0000	1.5
+++ reactos/apps/tests/isotest/isotest.c	3 Oct 2004 16:18:56 -0000
@@ -7,6 +7,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <ctype.h>
 #include <wchar.h>
 
 

Index: reactos/apps/testsets/loadlib/loadlib.c
===================================================================
RCS file: /CVS/ReactOS/reactos/apps/testsets/loadlib/loadlib.c,v
retrieving revision 1.2
diff -u -r1.2 loadlib.c
--- reactos/apps/testsets/loadlib/loadlib.c	14 Nov 2003 17:13:22 -0000	1.2
+++ reactos/apps/testsets/loadlib/loadlib.c	3 Oct 2004 16:21:50 -0000
@@ -23,6 +23,7 @@
 #include <windows.h>
 #include "loadlib.h"
 #include <string.h>
+#include <stdlib.h>
 #include <wchar.h>
 
 #define APP_VERSION 1

Index: reactos/drivers/lib/oskittcp/makefile
===================================================================
RCS file: /CVS/ReactOS/reactos/drivers/lib/oskittcp/makefile,v
retrieving revision 1.5
diff -u -r1.5 makefile
--- reactos/drivers/lib/oskittcp/makefile	23 Sep 2004 03:02:29 -0000	1.5
+++ reactos/drivers/lib/oskittcp/makefile	3 Oct 2004 16:08:22 -0000
@@ -14,7 +14,7 @@
 TARGET_CFLAGS = -g -D__REACTOS__=1 -D__NTDRIVER__ -DKERNEL -Iinclude/freebsd -Iinclude/freebsd/sys/include -Iinclude/freebsd/src/sys -Iinclude/freebsd/dev/include -Iinclude/freebsd/net/include -Iinclude -I$(PATH_TO_TOP)/w32api/include -I$(PATH_TO_TOP)/include
 
 # require os code to explicitly request A/W version of structs/functions
-TARGET_CFLAGS += -D_DISABLE_TIDENTS
+TARGET_CFLAGS += -D_DISABLE_TIDENTS -D__USE_W32API
 
 TARGET_ASFLAGS = -I $(PATH_TO_TOP)/include
 

Index: reactos/drivers/lib/oskittcp/include/freebsd/src/sys/sys/unistd.h
===================================================================
RCS file: /CVS/ReactOS/reactos/drivers/lib/oskittcp/include/freebsd/src/sys/sys/unistd.h,v
retrieving revision 1.1
diff -u -r1.1 unistd.h
--- reactos/drivers/lib/oskittcp/include/freebsd/src/sys/sys/unistd.h	29 May 2004 00:15:46 -0000	1.1
+++ reactos/drivers/lib/oskittcp/include/freebsd/src/sys/sys/unistd.h	3 Oct 2004 16:06:50 -0000
@@ -64,9 +64,15 @@
 #define	R_OK		0x04	/* test for read permission */
 
 /* whence values for lseek(2) */
+#ifndef SEEK_SET
 #define	SEEK_SET	0	/* set file offset to offset */
+#endif
+#ifndef SEEK_CUR
 #define	SEEK_CUR	1	/* set file offset to current plus offset */
+#endif
+#ifndef SEEK_END
 #define	SEEK_END	2	/* set file offset to EOF plus offset */
+#endif
 
 #ifndef _POSIX_SOURCE
 /* whence values for lseek(2); renamed by POSIX 1003.1 */
cvs diff: Diffing reactos/drivers/lib/oskittcp/oskittcp
Index: reactos/drivers/lib/oskittcp/oskittcp/interface.c
===================================================================
RCS file: /CVS/ReactOS/reactos/drivers/lib/oskittcp/oskittcp/interface.c,v
retrieving revision 1.15
diff -u -r1.15 interface.c
--- reactos/drivers/lib/oskittcp/oskittcp/interface.c	23 Sep 2004 12:43:49 -0000	1.15
+++ reactos/drivers/lib/oskittcp/oskittcp/interface.c	3 Oct 2004 16:09:28 -0000
@@ -1,4 +1,3 @@
-#include <stdio.h>
 #include <oskittcp.h>
 #include <oskitdebug.h>
 #include <sys/param.h>

Index: reactos/lib/iphlpapi/ipstats_reactos.c
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/iphlpapi/ipstats_reactos.c,v
retrieving revision 1.5
diff -u -r1.5 ipstats_reactos.c
--- reactos/lib/iphlpapi/ipstats_reactos.c	5 Mar 2004 04:50:01 -0000	1.5
+++ reactos/lib/iphlpapi/ipstats_reactos.c	3 Oct 2004 15:22:44 -0000
@@ -19,6 +19,8 @@
  * tcpip.sys
  */
 
+#include <stdio.h>
+
 #include "iphlpapi_private.h"
 #include "ipstats.h"
 #include "ifenum.h"

Index: reactos/lib/kernel32/k32.h
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/kernel32/k32.h,v
retrieving revision 1.10
diff -u -r1.10 k32.h
--- reactos/lib/kernel32/k32.h	19 Sep 2004 14:36:47 -0000	1.10
+++ reactos/lib/kernel32/k32.h	3 Oct 2004 15:39:38 -0000
@@ -7,6 +7,7 @@
 #include <stdio.h>
 #include <limits.h>
 #include <wchar.h>
+#include <ctype.h>
 #include <string.h>
 #include <assert.h>
 #include <ddk/ntddk.h>

Index: reactos/tools/wmc/getopt.c
===================================================================
RCS file: /CVS/ReactOS/reactos/tools/wmc/getopt.c,v
retrieving revision 1.2
diff -u -r1.2 getopt.c
--- reactos/tools/wmc/getopt.c	14 Nov 2003 17:13:36 -0000	1.2
+++ reactos/tools/wmc/getopt.c	3 Oct 2004 14:49:04 -0000
@@ -40,6 +40,9 @@
 #endif
 
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
 
 /* Comment out all this code if we are using the GNU C Library, and are not
    actually compiling the library itself.  This code is part of the GNU C