Index: lib/coredll/Makefile
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/coredll/Makefile,v
retrieving revision 1.2
diff -u -r1.2 Makefile
--- lib/coredll/Makefile	29 May 2004 21:24:43 -0000	1.2
+++ lib/coredll/Makefile	27 Sep 2004 07:07:49 -0000
@@ -5,6 +5,8 @@
 
 TARGET_NAME = coredll
 
+TARGET_MANGLED = yes
+
 TARGET_BASE=$(TARGET_BASE_LIB_COREDLL)
 
 # require os code to explicitly request A/W version of structs/functions
Index: lib/crtdll/makefile
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/crtdll/makefile,v
retrieving revision 1.67
diff -u -r1.67 makefile
--- lib/crtdll/makefile	16 Sep 2004 10:25:12 -0000	1.67
+++ lib/crtdll/makefile	27 Sep 2004 07:07:49 -0000
@@ -8,6 +8,8 @@
 
 TARGET_NAME = crtdll
 
+TARGET_MANGLED = yes
+
 TARGET_PCH = precomp.h
 
 TARGET_BASE = $(TARGET_BASE_LIB_CRTDLL)
Index: lib/msvcrt/Makefile
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/msvcrt/Makefile,v
retrieving revision 1.47
diff -u -r1.47 Makefile
--- lib/msvcrt/Makefile	27 Aug 2004 03:08:23 -0000	1.47
+++ lib/msvcrt/Makefile	27 Sep 2004 07:08:32 -0000
@@ -8,6 +8,8 @@
 
 TARGET_NAME = msvcrt
 
+TARGET_MANGLED = yes
+
 TARGET_PCH = precomp.h
 
 TARGET_BASE = $(TARGET_BASE_LIB_MSVCRT)
Index: lib/msvcrt20/Makefile
===================================================================
RCS file: /CVS/ReactOS/reactos/lib/msvcrt20/Makefile,v
retrieving revision 1.2
diff -u -r1.2 Makefile
--- lib/msvcrt20/Makefile	29 May 2004 21:24:44 -0000	1.2
+++ lib/msvcrt20/Makefile	27 Sep 2004 07:08:32 -0000
@@ -7,6 +7,8 @@
 
 TARGET_NAME = msvcrt20
 
+TARGET_MANGLED = yes
+
 TARGET_BASE = $(TARGET_BASE_LIB_MSVCRT20)
 
 TARGET_LFLAGS = -nostartfiles --enable-stdcall-fixup
Index: tools/helper.mk
===================================================================
RCS file: /CVS/ReactOS/reactos/tools/helper.mk,v
retrieving revision 1.80
diff -u -r1.80 helper.mk
--- tools/helper.mk	16 Sep 2004 10:25:17 -0000	1.80
+++ tools/helper.mk	27 Sep 2004 07:31:45 -0000
@@ -25,6 +25,7 @@
 #   $TARGET_CPPAPP     = C++ application (no,yes) (optional)
 #   $TARGET_HEADERS    = Header files that the object files depend on (optional)
 #   $TARGET_DEFNAME    = Base name of .def and .edf files (optional)
+#   $TARGET_MANGLED    = Export mangled names; do not use --kill-at (no,yes) (optional)
 #   $TARGET_BASENAME   = Base name of output file (overrides $TARGET_NAME if it exists) (optional)
 #   $TARGET_EXTENSION  = Extension of the output file (optional)
 #   $TARGET_DDKLIBS    = DDK libraries that are to be imported by the module (optional)
@@ -658,6 +659,10 @@
   MK_EXTRACMD :=
 endif
 
+ifneq ($(TARGET_MANGLED),yes)
+  MK_EXTRACMD += --kill-at
+endif
+
 # User mode targets
 ifeq ($(MK_MODE),user)
 
@@ -694,7 +699,7 @@
 	- $(RM) junk.tmp
 	$(DLLTOOL) --dllname $(MK_FULLNAME) \
 		--base-file base.tmp \
-		--output-exp temp.exp --kill-at $(MK_EXTRACMD)
+		--output-exp temp.exp $(MK_EXTRACMD)
 	- $(RM) base.tmp
 endif
 	$(LD_CC) $(TARGET_LFLAGS) \
@@ -736,7 +741,7 @@
 	- $(RM) junk.tmp
 	$(DLLTOOL) --dllname $(MK_FULLNAME) \
 		--base-file base.tmp \
-		--output-exp temp.exp --kill-at $(MK_EXTRACMD)
+		--output-exp temp.exp $(MK_EXTRACMD)
 	- $(RM) base.tmp
 endif
 	$(LD_CC) $(TARGET_LFLAGS) \
@@ -764,6 +769,10 @@
   MK_EXTRADEP :=
 endif
 
+ifneq ($(TARGET_MANGLED),yes)
+  MK_EXTRACMD += --kill-at
+endif
+
 $(MK_NOSTRIPNAME): $(MK_FULLRES) $(MK_OBJECTS) $(MK_EXTRADEP) $(MK_LIBS)
 	$(LD_CC) -Wl,--base-file,base.tmp \
 		-Wl,--entry,$(TARGET_ENTRY) \
@@ -774,7 +783,7 @@
 	- $(RM) junk.tmp
 	$(DLLTOOL) --dllname $(MK_FULLNAME) \
 		--base-file base.tmp \
-		--output-exp temp.exp $(MK_EXTRACMD) --kill-at
+		--output-exp temp.exp $(MK_EXTRACMD)
 	- $(RM) base.tmp
 	$(LD_CC) $(TARGET_LFLAGS) \
 		-Wl,--subsystem,native \
@@ -808,7 +817,7 @@
 	- $(RM) junk.tmp
 	$(DLLTOOL) --dllname $(MK_FULLNAME) \
 		--base-file base.tmp \
-		--output-exp temp.exp $(MK_EXTRACMD) --kill-at
+		--output-exp temp.exp $(MK_EXTRACMD)
 	- $(RM) base.tmp
 	$(LD_CC) $(TARGET_LFLAGS) \
 		-Wl,--subsystem,native \