--- E:\Sandbox\Ros\reactos\bootdata\hivesys.inf	Thu Aug 26 18:01:26 2004
+++ E:\Sandbox\ros_work\reactos\bootdata\hivesys.inf	Thu Aug 26 19:28:59 2004
@@ -159,11 +159,11 @@
 HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","0410",0x00000000,"l_intl.nls"
 HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","041d",0x00000000,"l_intl.nls"
 HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","0809",0x00000000,"l_intl.nls"
-HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","Default",0x00000000,"0409"
-HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","InstallLanguage",0x00000000,"0409"
+HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","Default",0x00000000,"0407"
+HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Language","InstallLanguage",0x00000000,"0407"
 
 ; Currently selected language for input
-HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Locale","(Default)",0x00000000,"00000409"
+HKLM,"SYSTEM\CurrentControlSet\Control\NLS\Locale","(Default)",0x00000000,"00000407"
 
 ; Service groups
 HKLM,"SYSTEM\CurrentControlSet\Control\ServiceGroupOrder","List",0x00010000, \
@@ -218,11 +218,16 @@
 ; Known DLLs
 HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","DllDirectory",0x00020000,"%SystemRoot%\system32"
 HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","advapi32",0x00000000,"advapi32.dll"
+HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","gdi32",0x00000000,"gdi32.dll"
 HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","kernel32",0x00000000,"kernel32.dll"
+HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","msvcrt",0x00000000,"msvcrt.dll"
+HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\KnownDlls","user32",0x00000000,"user32.dll"
+
 
 ; Pagefile settings
 HKLM,"SYSTEM\CurrentControlSet\Control\Session Manager\Memory Management","PagingFiles",0x00010000, \
- "C:\reactos\pagefile.sys"
+ "C:\pagefile.sys 32 32"
+
 
 ; 3Com 3c905 Driver
 HKLM,"SYSTEM\CurrentControlSet\Services\3c90x","ErrorControl",0x00010001,0x00000000
@@ -260,6 +265,20 @@
 HKLM,"SYSTEM\CurrentControlSet\Services\Afd","Start",0x00010001,0x00000002
 HKLM,"SYSTEM\CurrentControlSet\Services\Afd","Type",0x00010001,0x00000001
 
+; Promise Ultra100TX miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\ultra","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\ultra","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\ultra","ImagePath",0x00020000,"system32\drivers\ultra.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\ultra","Start",0x00010001,0x00000004
+HKLM,"SYSTEM\CurrentControlSet\Services\ultra","Type",0x00010001,0x00000001
+
+; HighPoint HPT3xx miniport driver
+;HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","ErrorControl",0x00010001,0x00000000
+;HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Group",0x00000000,"SCSI Miniport"
+;HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","ImagePath",0x00020000,"system32\drivers\hpt3xx.sys"
+;HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Start",0x00010001,0x00000000
+;HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Type",0x00010001,0x00000001
+
 ; Atapi miniport driver
 HKLM,"SYSTEM\CurrentControlSet\Services\Atapi","ErrorControl",0x00010001,0x00000000
 HKLM,"SYSTEM\CurrentControlSet\Services\Atapi","Group",0x00000000,"SCSI Miniport"
@@ -267,6 +286,70 @@
 HKLM,"SYSTEM\CurrentControlSet\Services\Atapi","Start",0x00010001,0x00000000
 HKLM,"SYSTEM\CurrentControlSet\Services\Atapi","Type",0x00010001,0x00000001
 
+; Initio A100 U2W Controller
+HKLM,"SYSTEM\CurrentControlSet\Services\inia100","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\inia100","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\inia100","ImagePath",0x00020000,"system32\drivers\inia100.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\inia100","Start",0x00010001,0x0000000
+HKLM,"SYSTEM\CurrentControlSet\Services\inia100","Type",0x00010001,0x00000001
+
+; Initio INI 950
+HKLM,"SYSTEM\CurrentControlSet\Services\ini910U","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\ini910U","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\ini910U","ImagePath",0x00020000,"system32\drivers\ini910u.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\ini910U","Start",0x00010001,0x0000000
+HKLM,"SYSTEM\CurrentControlSet\Services\ini910U","Type",0x00010001,0x00000001
+
+; Adaptec SCSI Controller 2940UW miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\aic78xx","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\aic78xx","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\aic78xx","ImagePath",0x00020000,"system32\drivers\aic78xx.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\aic78xx","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\aic78xx","Type",0x00010001,0x00000001
+
+; LSI Logic SCSI Controller 53C8xx miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\symc8xx","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\symc8xx","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\symc8xx","ImagePath",0x00020000,"system32\drivers\symc8xx.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\symc8xx","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\symc8xx","Type",0x00010001,0x00000001
+
+; Diamond Multimedia Fireport 40
+HKLM,"SYSTEM\CurrentControlSet\Services\fireport","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\fireport","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\fireport","ImagePath",0x00020000,"system32\drivers\fireport.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\fireport","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\fireport","Type",0x00010001,0x00000001
+
+; LSI Logic SCSI Controller 53C8xx miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\LSI875","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\LSI875","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\LSI875","ImagePath",0x00020000,"system32\drivers\lsi875.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\LSI875","Start",0x00010001,0x00000004
+HKLM,"SYSTEM\CurrentControlSet\Services\LSI875","Type",0x00010001,0x00000001
+
+; Initio 1060 U2W Controller
+HKLM,"SYSTEM\CurrentControlSet\Services\ini1060","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\ini1060","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\ini1060","ImagePath",0x00020000,"system32\drivers\ini1060.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\ini1060","Start",0x00010001,0x0000004
+HKLM,"SYSTEM\CurrentControlSet\Services\ini1060","Type",0x00010001,0x00000001
+
+; Tekram DC-390F SCSI Controller miniport driver (based on 53C857)
+HKLM,"SYSTEM\CurrentControlSet\Services\trm390w","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\trm390w","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\trm390w","ImagePath",0x00020000,"system32\drivers\trm390w.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\trm390w","Start",0x00010001,0x0000000
+HKLM,"SYSTEM\CurrentControlSet\Services\trm390w","Type",0x00010001,0x00000001
+
+; HighPoint HPT3xx miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Group",0x00000000,"SCSI Miniport"
+HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","ImagePath",0x00020000,"system32\drivers\hpt3xx.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Start",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\hpt3xxPCI","Type",0x00010001,0x00000001
+
+
 ; Beep device driver
 HKLM,"SYSTEM\CurrentControlSet\Services\Beep","ErrorControl",0x00010001,0x00000000
 HKLM,"SYSTEM\CurrentControlSet\Services\Beep","Group",0x00000000,"Base"
@@ -520,8 +603,8 @@
 HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters","TP",0x00000000,"1"
 HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters","SlotNumber",0x00000000,"10"
 HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters","BusNumber",0x00000000,"0"
-HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters\Tcpip","DefaultGateway",0x00010000,"10.0.0.1"
-HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters\Tcpip","IPAddress",0x00010000,"10.0.0.100"
+HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters\Tcpip","DefaultGateway",0x00010000,"192.168.3.1"
+HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters\Tcpip","IPAddress",0x00010000,"192.168.3.6"
 HKLM,"SYSTEM\CurrentControlSet\Services\PCNet1\Parameters\Tcpip","SubnetMask",0x00010000,"255.255.255.0"
 
 ; Configuration Entries for the PCNet Adapter
@@ -697,6 +780,14 @@
 HKLM,"SYSTEM\CurrentControlSet\Services\Vga","Start",0x00010001,0x00000004
 HKLM,"SYSTEM\CurrentControlSet\Services\Vga","Type",0x00010001,0x00000001
 HKLM,"SYSTEM\CurrentControlSet\Services\Vga\Device0","InstalledDisplayDrivers",0x00010000,"vgaddi"
+
+; ATI miniport driver
+HKLM,"SYSTEM\CurrentControlSet\Services\ati","ErrorControl",0x00010001,0x00000000
+HKLM,"SYSTEM\CurrentControlSet\Services\ati","Group",0x00000000,"Video"
+HKLM,"SYSTEM\CurrentControlSet\Services\ati","ImagePath",0x00020000,"system32\drivers\ati.sys"
+HKLM,"SYSTEM\CurrentControlSet\Services\ati","Start",0x00010001,0x00000004
+HKLM,"SYSTEM\CurrentControlSet\Services\ati","Type",0x00010001,0x00000001
+HKLM,"SYSTEM\CurrentControlSet\Services\ati\Device0","InstalledDisplayDrivers",0x00010000,"atiddi"
 
 ; VMware SVGA driver
 HKLM,"SYSTEM\CurrentControlSet\Services\vmx_svga","ErrorControl",0x00010001,0x00000000